Index: src/vector.cpp
===================================================================
--- src/vector.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/vector.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -6,18 +6,14 @@
 
 
-#include "defs.hpp"
-#include "helpers.hpp"
-#include "info.hpp"
-#include "gslmatrix.hpp"
-#include "leastsquaremin.hpp"
-#include "log.hpp"
-#include "memoryallocator.hpp"
 #include "vector.hpp"
 #include "verbose.hpp"
-
-#include <gsl/gsl_linalg.h>
-#include <gsl/gsl_matrix.h>
-#include <gsl/gsl_permutation.h>
-#include <gsl/gsl_vector.h>
+#include "World.hpp"
+#include "Helpers/Assert.hpp"
+#include "Helpers/fast_functions.hpp"
+
+#include <iostream>
+
+using namespace std;
+
 
 /************************************ Functions for class vector ************************************/
@@ -25,9 +21,41 @@
 /** Constructor of class vector.
  */
-Vector::Vector() { x[0] = x[1] = x[2] = 0.; };
+Vector::Vector()
+{
+  x[0] = x[1] = x[2] = 0.;
+};
+
+/**
+ * Copy constructor
+ */
+
+Vector::Vector(const Vector& src)
+{
+  x[0] = src[0];
+  x[1] = src[1];
+  x[2] = src[2];
+}
 
 /** Constructor of class vector.
  */
-Vector::Vector(const double x1, const double x2, const double x3) { x[0] = x1; x[1] = x2; x[2] = x3; };
+Vector::Vector(const double x1, const double x2, const double x3)
+{
+  x[0] = x1;
+  x[1] = x2;
+  x[2] = x3;
+};
+
+/**
+ * Assignment operator
+ */
+Vector& Vector::operator=(const Vector& src){
+  // check for self assignment
+  if(&src!=this){
+    x[0] = src[0];
+    x[1] = src[1];
+    x[2] = src[2];
+  }
+  return *this;
+}
 
 /** Desctructor of class vector.
@@ -39,9 +67,9 @@
  * \return \f$| x - y |^2\f$
  */
-double Vector::DistanceSquared(const Vector * const y) const
+double Vector::DistanceSquared(const Vector &y) const
 {
   double res = 0.;
   for (int i=NDIM;i--;)
-    res += (x[i]-y->x[i])*(x[i]-y->x[i]);
+    res += (x[i]-y[i])*(x[i]-y[i]);
   return (res);
 };
@@ -51,11 +79,13 @@
  * \return \f$| x - y |\f$
  */
-double Vector::Distance(const Vector * const y) const
-{
-  double res = 0.;
-  for (int i=NDIM;i--;)
-    res += (x[i]-y->x[i])*(x[i]-y->x[i]);
-  return (sqrt(res));
-};
+double Vector::distance(const Vector &y) const
+{
+  return (sqrt(DistanceSquared(y)));
+};
+
+Vector Vector::getClosestPoint(const Vector &point) const{
+  // the closest point to a single point space is always the single point itself
+  return *this;
+}
 
 /** Calculates distance between this and another vector in a periodic cell.
@@ -64,35 +94,34 @@
  * \return \f$| x - y |\f$
  */
-double Vector::PeriodicDistance(const Vector * const y, const double * const cell_size) const
-{
-  double res = Distance(y), tmp, matrix[NDIM*NDIM];
-  Vector Shiftedy, TranslationVector;
-  int N[NDIM];
-  matrix[0] = cell_size[0];
-  matrix[1] = cell_size[1];
-  matrix[2] = cell_size[3];
-  matrix[3] = cell_size[1];
-  matrix[4] = cell_size[2];
-  matrix[5] = cell_size[4];
-  matrix[6] = cell_size[3];
-  matrix[7] = cell_size[4];
-  matrix[8] = cell_size[5];
-  // in order to check the periodic distance, translate one of the vectors into each of the 27 neighbouring cells
-  for (N[0]=-1;N[0]<=1;N[0]++)
-    for (N[1]=-1;N[1]<=1;N[1]++)
-      for (N[2]=-1;N[2]<=1;N[2]++) {
-        // create the translation vector
-        TranslationVector.Zero();
-        for (int i=NDIM;i--;)
-          TranslationVector.x[i] = (double)N[i];
-        TranslationVector.MatrixMultiplication(matrix);
-        // add onto the original vector to compare with
-        Shiftedy.CopyVector(y);
-        Shiftedy.AddVector(&TranslationVector);
-        // get distance and compare with minimum so far
-        tmp = Distance(&Shiftedy);
-        if (tmp < res) res = tmp;
-      }
-  return (res);
+double Vector::PeriodicDistance(const Vector &y, const double * const cell_size) const
+{
+  double res = distance(y), tmp, matrix[NDIM*NDIM];
+    Vector Shiftedy, TranslationVector;
+    int N[NDIM];
+    matrix[0] = cell_size[0];
+    matrix[1] = cell_size[1];
+    matrix[2] = cell_size[3];
+    matrix[3] = cell_size[1];
+    matrix[4] = cell_size[2];
+    matrix[5] = cell_size[4];
+    matrix[6] = cell_size[3];
+    matrix[7] = cell_size[4];
+    matrix[8] = cell_size[5];
+    // in order to check the periodic distance, translate one of the vectors into each of the 27 neighbouring cells
+    for (N[0]=-1;N[0]<=1;N[0]++)
+      for (N[1]=-1;N[1]<=1;N[1]++)
+        for (N[2]=-1;N[2]<=1;N[2]++) {
+          // create the translation vector
+          TranslationVector.Zero();
+          for (int i=NDIM;i--;)
+            TranslationVector[i] = (double)N[i];
+          TranslationVector.MatrixMultiplication(matrix);
+          // add onto the original vector to compare with
+          Shiftedy = y + TranslationVector;
+          // get distance and compare with minimum so far
+          tmp = distance(Shiftedy);
+          if (tmp < res) res = tmp;
+        }
+    return (res);
 };
 
@@ -102,35 +131,34 @@
  * \return \f$| x - y |^2\f$
  */
-double Vector::PeriodicDistanceSquared(const Vector * const y, const double * const cell_size) const
+double Vector::PeriodicDistanceSquared(const Vector &y, const double * const cell_size) const
 {
   double res = DistanceSquared(y), tmp, matrix[NDIM*NDIM];
-  Vector Shiftedy, TranslationVector;
-  int N[NDIM];
-  matrix[0] = cell_size[0];
-  matrix[1] = cell_size[1];
-  matrix[2] = cell_size[3];
-  matrix[3] = cell_size[1];
-  matrix[4] = cell_size[2];
-  matrix[5] = cell_size[4];
-  matrix[6] = cell_size[3];
-  matrix[7] = cell_size[4];
-  matrix[8] = cell_size[5];
-  // in order to check the periodic distance, translate one of the vectors into each of the 27 neighbouring cells
-  for (N[0]=-1;N[0]<=1;N[0]++)
-    for (N[1]=-1;N[1]<=1;N[1]++)
-      for (N[2]=-1;N[2]<=1;N[2]++) {
-        // create the translation vector
-        TranslationVector.Zero();
-        for (int i=NDIM;i--;)
-          TranslationVector.x[i] = (double)N[i];
-        TranslationVector.MatrixMultiplication(matrix);
-        // add onto the original vector to compare with
-        Shiftedy.CopyVector(y);
-        Shiftedy.AddVector(&TranslationVector);
-        // get distance and compare with minimum so far
-        tmp = DistanceSquared(&Shiftedy);
-        if (tmp < res) res = tmp;
-      }
-  return (res);
+    Vector Shiftedy, TranslationVector;
+    int N[NDIM];
+    matrix[0] = cell_size[0];
+    matrix[1] = cell_size[1];
+    matrix[2] = cell_size[3];
+    matrix[3] = cell_size[1];
+    matrix[4] = cell_size[2];
+    matrix[5] = cell_size[4];
+    matrix[6] = cell_size[3];
+    matrix[7] = cell_size[4];
+    matrix[8] = cell_size[5];
+    // in order to check the periodic distance, translate one of the vectors into each of the 27 neighbouring cells
+    for (N[0]=-1;N[0]<=1;N[0]++)
+      for (N[1]=-1;N[1]<=1;N[1]++)
+        for (N[2]=-1;N[2]<=1;N[2]++) {
+          // create the translation vector
+          TranslationVector.Zero();
+          for (int i=NDIM;i--;)
+            TranslationVector[i] = (double)N[i];
+          TranslationVector.MatrixMultiplication(matrix);
+          // add onto the original vector to compare with
+          Shiftedy = y + TranslationVector;
+          // get distance and compare with minimum so far
+          tmp = DistanceSquared(Shiftedy);
+          if (tmp < res) res = tmp;
+        }
+    return (res);
 };
 
@@ -141,27 +169,24 @@
 void Vector::KeepPeriodic(const double * const matrix)
 {
-//  int N[NDIM];
-//  bool flag = false;
-  //vector Shifted, TranslationVector;
-  Vector TestVector;
-//  Log() << Verbose(1) << "Begin of KeepPeriodic." << endl;
-//  Log() << Verbose(2) << "Vector is: ";
-//  Output(out);
-//  Log() << Verbose(0) << endl;
-  TestVector.CopyVector(this);
-  TestVector.InverseMatrixMultiplication(matrix);
-  for(int i=NDIM;i--;) { // correct periodically
-    if (TestVector.x[i] < 0) {  // get every coefficient into the interval [0,1)
-      TestVector.x[i] += ceil(TestVector.x[i]);
-    } else {
-      TestVector.x[i] -= floor(TestVector.x[i]);
+  //  int N[NDIM];
+  //  bool flag = false;
+    //vector Shifted, TranslationVector;
+  //  Log() << Verbose(1) << "Begin of KeepPeriodic." << endl;
+  //  Log() << Verbose(2) << "Vector is: ";
+  //  Output(out);
+  //  Log() << Verbose(0) << endl;
+    InverseMatrixMultiplication(matrix);
+    for(int i=NDIM;i--;) { // correct periodically
+      if (at(i) < 0) {  // get every coefficient into the interval [0,1)
+        at(i) += ceil(at(i));
+      } else {
+        at(i) -= floor(at(i));
+      }
     }
-  }
-  TestVector.MatrixMultiplication(matrix);
-  CopyVector(&TestVector);
-//  Log() << Verbose(2) << "New corrected vector is: ";
-//  Output(out);
-//  Log() << Verbose(0) << endl;
-//  Log() << Verbose(1) << "End of KeepPeriodic." << endl;
+    MatrixMultiplication(matrix);
+  //  Log() << Verbose(2) << "New corrected vector is: ";
+  //  Output(out);
+  //  Log() << Verbose(0) << endl;
+  //  Log() << Verbose(1) << "End of KeepPeriodic." << endl;
 };
 
@@ -170,9 +195,9 @@
  * \return \f$\langle x, y \rangle\f$
  */
-double Vector::ScalarProduct(const Vector * const y) const
+double Vector::ScalarProduct(const Vector &y) const
 {
   double res = 0.;
   for (int i=NDIM;i--;)
-    res += x[i]*y->x[i];
+    res += x[i]*y[i];
   return (res);
 };
@@ -185,11 +210,11 @@
  *  \return \f$ x \times y \f&
  */
-void Vector::VectorProduct(const Vector * const y)
+void Vector::VectorProduct(const Vector &y)
 {
   Vector tmp;
-  tmp.x[0] = x[1]* (y->x[2]) - x[2]* (y->x[1]);
-  tmp.x[1] = x[2]* (y->x[0]) - x[0]* (y->x[2]);
-  tmp.x[2] = x[0]* (y->x[1]) - x[1]* (y->x[0]);
-  this->CopyVector(&tmp);
+  tmp[0] = x[1]* (y[2]) - x[2]* (y[1]);
+  tmp[1] = x[2]* (y[0]) - x[0]* (y[2]);
+  tmp[2] = x[0]* (y[1]) - x[1]* (y[0]);
+  (*this) = tmp;
 };
 
@@ -199,90 +224,27 @@
  * \return \f$\langle x, y \rangle\f$
  */
-void Vector::ProjectOntoPlane(const Vector * const y)
+void Vector::ProjectOntoPlane(const Vector &y)
 {
   Vector tmp;
-  tmp.CopyVector(y);
+  tmp = y;
   tmp.Normalize();
-  tmp.Scale(ScalarProduct(&tmp));
-  this->SubtractVector(&tmp);
-};
-
-/** Calculates the intersection point between a line defined by \a *LineVector and \a *LineVector2 and a plane defined by \a *Normal and \a *PlaneOffset.
- * According to [Bronstein] the vectorial plane equation is:
- *   -# \f$\stackrel{r}{\rightarrow} \cdot \stackrel{N}{\rightarrow} + D = 0\f$,
- * where \f$\stackrel{r}{\rightarrow}\f$ is the vector to be testet, \f$\stackrel{N}{\rightarrow}\f$ is the plane's normal vector and
- * \f$D = - \stackrel{a}{\rightarrow} \stackrel{N}{\rightarrow}\f$, the offset with respect to origin, if \f$\stackrel{a}{\rightarrow}\f$,
- * is an offset vector onto the plane. The line is parametrized by \f$\stackrel{x}{\rightarrow} + k \stackrel{t}{\rightarrow}\f$, where
- * \f$\stackrel{x}{\rightarrow}\f$ is the offset and \f$\stackrel{t}{\rightarrow}\f$ the directional vector (NOTE: No need to normalize
- * the latter). Inserting the parametrized form into the plane equation and solving for \f$k\f$, which we insert then into the parametrization
- * of the line yields the intersection point on the plane.
- * \param *out output stream for debugging
- * \param *PlaneNormal Plane's normal vector
- * \param *PlaneOffset Plane's offset vector
- * \param *Origin first vector of line
- * \param *LineVector second vector of line
- * \return true -  \a this contains intersection point on return, false - line is parallel to plane (even if in-plane)
- */
-bool Vector::GetIntersectionWithPlane(const Vector * const PlaneNormal, const Vector * const PlaneOffset, const Vector * const Origin, const Vector * const LineVector)
-{
-  Info FunctionInfo(__func__);
-  double factor;
-  Vector Direction, helper;
-
-  // find intersection of a line defined by Offset and Direction with a  plane defined by triangle
-  Direction.CopyVector(LineVector);
-  Direction.SubtractVector(Origin);
-  Direction.Normalize();
-  Log() << Verbose(1) << "INFO: Direction is " << Direction << "." << endl;
-  //Log() << Verbose(1) << "INFO: PlaneNormal is " << *PlaneNormal << " and PlaneOffset is " << *PlaneOffset << "." << endl;
-  factor = Direction.ScalarProduct(PlaneNormal);
-  if (fabs(factor) < MYEPSILON) { // Uniqueness: line parallel to plane?
-    Log() << Verbose(1) << "BAD: Line is parallel to plane, no intersection." << endl;
-    return false;
-  }
-  helper.CopyVector(PlaneOffset);
-  helper.SubtractVector(Origin);
-  factor = helper.ScalarProduct(PlaneNormal)/factor;
-  if (fabs(factor) < MYEPSILON) { // Origin is in-plane
-    Log() << Verbose(1) << "GOOD: Origin of line is in-plane." << endl;
-    CopyVector(Origin);
-    return true;
-  }
-  //factor = Origin->ScalarProduct(PlaneNormal)*(-PlaneOffset->ScalarProduct(PlaneNormal))/(Direction.ScalarProduct(PlaneNormal));
-  Direction.Scale(factor);
-  CopyVector(Origin);
-  Log() << Verbose(1) << "INFO: Scaled direction is " << Direction << "." << endl;
-  AddVector(&Direction);
-
-  // test whether resulting vector really is on plane
-  helper.CopyVector(this);
-  helper.SubtractVector(PlaneOffset);
-  if (helper.ScalarProduct(PlaneNormal) < MYEPSILON) {
-    Log() << Verbose(1) << "GOOD: Intersection is " << *this << "." << endl;
-    return true;
-  } else {
-    eLog() << Verbose(2) << "Intersection point " << *this << " is not on plane." << endl;
-    return false;
-  }
-};
-
-/** Calculates the minimum distance of this vector to the plane.
+  tmp.Scale(ScalarProduct(tmp));
+  *this -= tmp;
+};
+
+/** Calculates the minimum distance vector of this vector to the plane.
  * \param *out output stream for debugging
  * \param *PlaneNormal normal of plane
  * \param *PlaneOffset offset of plane
  * \return distance to plane
- */
-double Vector::DistanceToPlane(const Vector * const PlaneNormal, const Vector * const PlaneOffset) const
-{
-  Vector temp;
-
-  // first create part that is orthonormal to PlaneNormal with withdraw
-  temp.CopyVector(this);
-  temp.SubtractVector(PlaneOffset);
-  temp.MakeNormalVector(PlaneNormal);
+ * \return distance vector onto to plane
+ */
+Vector Vector::GetDistanceVectorToPlane(const Vector &PlaneNormal, const Vector &PlaneOffset) const
+{
+  Vector temp = (*this) - PlaneOffset;
+  temp.MakeNormalTo(PlaneNormal);
   temp.Scale(-1.);
   // then add connecting vector from plane to point
-  temp.AddVector(this);
-  temp.SubtractVector(PlaneOffset);
+  temp += (*this)-PlaneOffset;
   double sign = temp.ScalarProduct(PlaneNormal);
   if (fabs(sign) > MYEPSILON)
@@ -291,111 +253,20 @@
     sign = 0.;
 
-  return (temp.Norm()*sign);
-};
-
-/** Calculates the intersection of the two lines that are both on the same plane.
- * This is taken from Weisstein, Eric W. "Line-Line Intersection." From MathWorld--A Wolfram Web Resource. http://mathworld.wolfram.com/Line-LineIntersection.html 
+  temp.Normalize();
+  temp.Scale(sign);
+  return temp;
+};
+
+
+/** Calculates the minimum distance of this vector to the plane.
+ * \sa Vector::GetDistanceVectorToPlane()
  * \param *out output stream for debugging
- * \param *Line1a first vector of first line
- * \param *Line1b second vector of first line
- * \param *Line2a first vector of second line
- * \param *Line2b second vector of second line
- * \param *PlaneNormal normal of plane, is supplemental/arbitrary
- * \return true - \a this will contain the intersection on return, false - lines are parallel
- */
-bool Vector::GetIntersectionOfTwoLinesOnPlane(const Vector * const Line1a, const Vector * const Line1b, const Vector * const Line2a, const Vector * const Line2b, const Vector *PlaneNormal)
-{
-  Info FunctionInfo(__func__);
-
-  GSLMatrix *M = new GSLMatrix(4,4);
-
-  M->SetAll(1.);
-  for (int i=0;i<3;i++) {
-    M->Set(0, i, Line1a->x[i]);
-    M->Set(1, i, Line1b->x[i]);
-    M->Set(2, i, Line2a->x[i]);
-    M->Set(3, i, Line2b->x[i]);
-  }
-  
-  //Log() << Verbose(1) << "Coefficent matrix is:" << endl;
-  //for (int i=0;i<4;i++) {
-  //  for (int j=0;j<4;j++)
-  //    cout << "\t" << M->Get(i,j);
-  //  cout << endl;
-  //}
-  if (fabs(M->Determinant()) > MYEPSILON) {
-    Log() << Verbose(1) << "Determinant of coefficient matrix is NOT zero." << endl;
-    return false;
-  }
-  Log() << Verbose(1) << "INFO: Line1a = " << *Line1a << ", Line1b = " << *Line1b << ", Line2a = " << *Line2a << ", Line2b = " << *Line2b << "." << endl;
-
-
-  // constuct a,b,c
-  Vector a;
-  Vector b;
-  Vector c;
-  Vector d;
-  a.CopyVector(Line1b);
-  a.SubtractVector(Line1a);
-  b.CopyVector(Line2b);
-  b.SubtractVector(Line2a);
-  c.CopyVector(Line2a);
-  c.SubtractVector(Line1a);
-  d.CopyVector(Line2b);
-  d.SubtractVector(Line1b);
-  Log() << Verbose(1) << "INFO: a = " << a << ", b = " << b << ", c = " << c << "." << endl;
-  if ((a.NormSquared() < MYEPSILON) || (b.NormSquared() < MYEPSILON)) {
-   Zero();
-   Log() << Verbose(1) << "At least one of the lines is ill-defined, i.e. offset equals second vector." << endl;
-   return false;
-  }
-
-  // check for parallelity
-  Vector parallel;
-  double factor = 0.;
-  if (fabs(a.ScalarProduct(&b)*a.ScalarProduct(&b)/a.NormSquared()/b.NormSquared() - 1.) < MYEPSILON) {
-    parallel.CopyVector(Line1a);
-    parallel.SubtractVector(Line2a);
-    factor = parallel.ScalarProduct(&a)/a.Norm();
-    if ((factor >= -MYEPSILON) && (factor - 1. < MYEPSILON)) {
-      CopyVector(Line2a);
-      Log() << Verbose(1) << "Lines conincide." << endl;
-      return true;
-    } else {
-      parallel.CopyVector(Line1a);
-      parallel.SubtractVector(Line2b);
-      factor = parallel.ScalarProduct(&a)/a.Norm();
-      if ((factor >= -MYEPSILON) && (factor - 1. < MYEPSILON)) {
-        CopyVector(Line2b);
-        Log() << Verbose(1) << "Lines conincide." << endl;
-        return true;
-      }
-    }
-    Log() << Verbose(1) << "Lines are parallel." << endl;
-    Zero();
-    return false;
-  }
-
-  // obtain s
-  double s;
-  Vector temp1, temp2;
-  temp1.CopyVector(&c);
-  temp1.VectorProduct(&b);
-  temp2.CopyVector(&a);
-  temp2.VectorProduct(&b);
-  Log() << Verbose(1) << "INFO: temp1 = " << temp1 << ", temp2 = " << temp2 << "." << endl;
-  if (fabs(temp2.NormSquared()) > MYEPSILON)
-    s = temp1.ScalarProduct(&temp2)/temp2.NormSquared();
-  else
-    s = 0.;
-  Log() << Verbose(1) << "Factor s is " << temp1.ScalarProduct(&temp2) << "/" << temp2.NormSquared() << " = " << s << "." << endl;
-
-  // construct intersection
-  CopyVector(&a);
-  Scale(s);
-  AddVector(Line1a);
-  Log() << Verbose(1) << "Intersection is at " << *this << "." << endl;
-
-  return true;
+ * \param *PlaneNormal normal of plane
+ * \param *PlaneOffset offset of plane
+ * \return distance to plane
+ */
+double Vector::DistanceToPlane(const Vector &PlaneNormal, const Vector &PlaneOffset) const
+{
+  return GetDistanceVectorToPlane(PlaneNormal,PlaneOffset).Norm();
 };
 
@@ -403,9 +274,7 @@
  * \param *y array to second vector
  */
-void Vector::ProjectIt(const Vector * const y)
-{
-  Vector helper(*y);
-  helper.Scale(-(ScalarProduct(y)));
-  AddVector(&helper);
+void Vector::ProjectIt(const Vector &y)
+{
+  (*this) += (-ScalarProduct(y))*y;
 };
 
@@ -414,8 +283,8 @@
  * \return Vector
  */
-Vector Vector::Projection(const Vector * const y) const
-{
-  Vector helper(*y);
-  helper.Scale((ScalarProduct(y)/y->NormSquared()));
+Vector Vector::Projection(const Vector &y) const
+{
+  Vector helper = y;
+  helper.Scale((ScalarProduct(y)/y.NormSquared()));
 
   return helper;
@@ -427,8 +296,5 @@
 double Vector::Norm() const
 {
-  double res = 0.;
-  for (int i=NDIM;i--;)
-    res += this->x[i]*this->x[i];
-  return (sqrt(res));
+  return (sqrt(NormSquared()));
 };
 
@@ -438,5 +304,5 @@
 double Vector::NormSquared() const
 {
-  return (ScalarProduct(this));
+  return (ScalarProduct(*this));
 };
 
@@ -445,10 +311,6 @@
 void Vector::Normalize()
 {
-  double res = 0.;
-  for (int i=NDIM;i--;)
-    res += this->x[i]*this->x[i];
-  if (fabs(res) > MYEPSILON)
-    res = 1./sqrt(res);
-  Scale(&res);
+  double factor = Norm();
+  (*this) *= 1/factor;
 };
 
@@ -457,6 +319,5 @@
 void Vector::Zero()
 {
-  for (int i=NDIM;i--;)
-    this->x[i] = 0.;
+  at(0)=at(1)=at(2)=0;
 };
 
@@ -465,15 +326,5 @@
 void Vector::One(const double one)
 {
-  for (int i=NDIM;i--;)
-    this->x[i] = one;
-};
-
-/** Initialises all components of this vector.
- */
-void Vector::Init(const double x1, const double x2, const double x3)
-{
-  x[0] = x1;
-  x[1] = x2;
-  x[2] = x3;
+  at(0)=at(1)=at(2)=one;
 };
 
@@ -497,5 +348,5 @@
  * @return true - vector is normalized, false - vector is not
  */
-bool Vector::IsNormalTo(const Vector * const normal) const
+bool Vector::IsNormalTo(const Vector &normal) const
 {
   if (ScalarProduct(normal) < MYEPSILON)
@@ -508,9 +359,9 @@
  * @return true - vector is normalized, false - vector is not
  */
-bool Vector::IsEqualTo(const Vector * const a) const
+bool Vector::IsEqualTo(const Vector &a) const
 {
   bool status = true;
   for (int i=0;i<NDIM;i++) {
-    if (fabs(x[i] - a->x[i]) > MYEPSILON)
+    if (fabs(x[i] - a[i]) > MYEPSILON)
       status = false;
   }
@@ -522,7 +373,7 @@
  * \return \f$\acos\bigl(frac{\langle x, y \rangle}{|x||y|}\bigr)\f$
  */
-double Vector::Angle(const Vector * const y) const
-{
-  double norm1 = Norm(), norm2 = y->Norm();
+double Vector::Angle(const Vector &y) const
+{
+  double norm1 = Norm(), norm2 = y.Norm();
   double angle = -1;
   if ((fabs(norm1) > MYEPSILON) && (fabs(norm2) > MYEPSILON))
@@ -537,31 +388,26 @@
 };
 
-/** Rotates the vector relative to the origin around the axis given by \a *axis by an angle of \a alpha.
- * \param *axis rotation axis
- * \param alpha rotation angle in radian
- */
-void Vector::RotateVector(const Vector * const axis, const double alpha)
-{
-  Vector a,y;
-  // normalise this vector with respect to axis
-  a.CopyVector(this);
-  a.ProjectOntoPlane(axis);
-  // construct normal vector
-  bool rotatable = y.MakeNormalVector(axis,&a);
-  // The normal vector cannot be created if there is linar dependency.
-  // Then the vector to rotate is on the axis and any rotation leads to the vector itself.
-  if (!rotatable) {
-    return;
-  }
-  y.Scale(Norm());
-  // scale normal vector by sine and this vector by cosine
-  y.Scale(sin(alpha));
-  a.Scale(cos(alpha));
-  CopyVector(Projection(axis));
-  // add scaled normal vector onto this vector
-  AddVector(&y);
-  // add part in axis direction
-  AddVector(&a);
-};
+
+double& Vector::operator[](size_t i){
+  ASSERT(i<=NDIM && i>=0,"Vector Index out of Range");
+  return x[i];
+}
+
+const double& Vector::operator[](size_t i) const{
+  ASSERT(i<=NDIM && i>=0,"Vector Index out of Range");
+  return x[i];
+}
+
+double& Vector::at(size_t i){
+  return (*this)[i];
+}
+
+const double& Vector::at(size_t i) const{
+  return (*this)[i];
+}
+
+double* Vector::get(){
+  return x;
+}
 
 /** Compares vector \a to vector \a b component-wise.
@@ -570,11 +416,13 @@
  * \return a == b
  */
-bool operator==(const Vector& a, const Vector& b)
-{
-  bool status = true;
-  for (int i=0;i<NDIM;i++)
-    status = status && (fabs(a.x[i] - b.x[i]) < MYEPSILON);
-  return status;
-};
+bool Vector::operator==(const Vector& b) const
+{
+  return IsEqualTo(b);
+};
+
+bool Vector::operator!=(const Vector& b) const
+{
+  return !IsEqualTo(b);
+}
 
 /** Sums vector \a to this lhs component-wise.
@@ -583,8 +431,8 @@
  * \return lhs + a
  */
-Vector& operator+=(Vector& a, const Vector& b)
-{
-  a.AddVector(&b);
-  return a;
+const Vector& Vector::operator+=(const Vector& b)
+{
+  this->AddVector(b);
+  return *this;
 };
 
@@ -594,8 +442,8 @@
  * \return lhs - a
  */
-Vector& operator-=(Vector& a, const Vector& b)
-{
-  a.SubtractVector(&b);
-  return a;
+const Vector& Vector::operator-=(const Vector& b)
+{
+  this->SubtractVector(b);
+  return *this;
 };
 
@@ -605,5 +453,5 @@
  * \return lhs.x[i] * m
  */
-Vector& operator*=(Vector& a, const double m)
+const Vector& operator*=(Vector& a, const double m)
 {
   a.Scale(m);
@@ -616,10 +464,9 @@
  * \return a + b
  */
-Vector& operator+(const Vector& a, const Vector& b)
-{
-  Vector *x = new Vector;
-  x->CopyVector(&a);
-  x->AddVector(&b);
-  return *x;
+Vector const Vector::operator+(const Vector& b) const
+{
+  Vector x = *this;
+  x.AddVector(b);
+  return x;
 };
 
@@ -629,10 +476,9 @@
  * \return a - b
  */
-Vector& operator-(const Vector& a, const Vector& b)
-{
-  Vector *x = new Vector;
-  x->CopyVector(&a);
-  x->SubtractVector(&b);
-  return *x;
+Vector const Vector::operator-(const Vector& b) const
+{
+  Vector x = *this;
+  x.SubtractVector(b);
+  return x;
 };
 
@@ -642,10 +488,9 @@
  * \return m * a
  */
-Vector& operator*(const Vector& a, const double m)
-{
-  Vector *x = new Vector;
-  x->CopyVector(&a);
-  x->Scale(m);
-  return *x;
+Vector const operator*(const Vector& a, const double m)
+{
+  Vector x(a);
+  x.Scale(m);
+  return x;
 };
 
@@ -655,29 +500,9 @@
  * \return m * a
  */
-Vector& operator*(const double m, const Vector& a )
-{
-  Vector *x = new Vector;
-  x->CopyVector(&a);
-  x->Scale(m);
-  return *x;
-};
-
-Vector& Vector::operator=(const Vector& src) {
-  CopyVector(src);
-  return *this;
-}
-
-/** Prints a 3dim vector.
- * prints no end of line.
- */
-void Vector::Output() const
-{
-  Log() << Verbose(0) << "(";
-  for (int i=0;i<NDIM;i++) {
-    Log() << Verbose(0) << x[i];
-    if (i != 2)
-      Log() << Verbose(0) << ",";
-  }
-  Log() << Verbose(0) << ")";
+Vector const operator*(const double m, const Vector& a )
+{
+  Vector x(a);
+  x.Scale(m);
+  return x;
 };
 
@@ -686,5 +511,5 @@
   ost << "(";
   for (int i=0;i<NDIM;i++) {
-    ost << m.x[i];
+    ost << m[i];
     if (i != 2)
       ost << ",";
@@ -694,18 +519,12 @@
 };
 
-/** Scales each atom coordinate by an individual \a factor.
- * \param *factor pointer to scaling factor
- */
-void Vector::Scale(const double ** const factor)
+
+void Vector::ScaleAll(const double *factor)
 {
   for (int i=NDIM;i--;)
-    x[i] *= (*factor)[i];
-};
-
-void Vector::Scale(const double * const factor)
-{
-  for (int i=NDIM;i--;)
-    x[i] *= *factor;
-};
+    x[i] *= factor[i];
+};
+
+
 
 void Vector::Scale(const double factor)
@@ -713,13 +532,4 @@
   for (int i=NDIM;i--;)
     x[i] *= factor;
-};
-
-/** Translate atom by given vector.
- * \param trans[] translation vector.
- */
-void Vector::Translate(const Vector * const trans)
-{
-  for (int i=NDIM;i--;)
-    x[i] += trans->x[i];
 };
 
@@ -747,12 +557,8 @@
 void Vector::MatrixMultiplication(const double * const M)
 {
-  Vector C;
   // do the matrix multiplication
-  C.x[0] = M[0]*x[0]+M[3]*x[1]+M[6]*x[2];
-  C.x[1] = M[1]*x[0]+M[4]*x[1]+M[7]*x[2];
-  C.x[2] = M[2]*x[0]+M[5]*x[1]+M[8]*x[2];
-  // transfer the result into this
-  for (int i=NDIM;i--;)
-    x[i] = C.x[i];
+  at(0) = M[0]*x[0]+M[3]*x[1]+M[6]*x[2];
+  at(1) = M[1]*x[0]+M[4]*x[1]+M[7]*x[2];
+  at(2) = M[2]*x[0]+M[5]*x[1]+M[8]*x[2];
 };
 
@@ -760,7 +566,6 @@
  * \param *matrix NDIM_NDIM array
  */
-void Vector::InverseMatrixMultiplication(const double * const A)
-{
-  Vector C;
+bool Vector::InverseMatrixMultiplication(const double * const A)
+{
   double B[NDIM*NDIM];
   double detA = RDET3(A);
@@ -781,12 +586,11 @@
 
     // do the matrix multiplication
-    C.x[0] = B[0]*x[0]+B[3]*x[1]+B[6]*x[2];
-    C.x[1] = B[1]*x[0]+B[4]*x[1]+B[7]*x[2];
-    C.x[2] = B[2]*x[0]+B[5]*x[1]+B[8]*x[2];
-    // transfer the result into this
-    for (int i=NDIM;i--;)
-      x[i] = C.x[i];
+    at(0) = B[0]*x[0]+B[3]*x[1]+B[6]*x[2];
+    at(1) = B[1]*x[0]+B[4]*x[1]+B[7]*x[2];
+    at(2) = B[2]*x[0]+B[5]*x[1]+B[8]*x[2];
+
+    return true;
   } else {
-    eLog() << Verbose(1) << "inverse of matrix does not exists: det A = " << detA << "." << endl;
+    return false;
   }
 };
@@ -800,8 +604,9 @@
  * \param *factors three-component vector with the factor for each given vector
  */
-void Vector::LinearCombinationOfVectors(const Vector * const x1, const Vector * const x2, const Vector * const x3, const double * const factors)
-{
-  for(int i=NDIM;i--;)
-    x[i] = factors[0]*x1->x[i] + factors[1]*x2->x[i] + factors[2]*x3->x[i];
+void Vector::LinearCombinationOfVectors(const Vector &x1, const Vector &x2, const Vector &x3, const double * const factors)
+{
+  (*this) = (factors[0]*x1) +
+            (factors[1]*x2) +
+            (factors[2]*x3);
 };
 
@@ -809,85 +614,11 @@
  * \param n[] normal vector of mirror plane.
  */
-void Vector::Mirror(const Vector * const n)
+void Vector::Mirror(const Vector &n)
 {
   double projection;
-  projection = ScalarProduct(n)/n->ScalarProduct(n);    // remove constancy from n (keep as logical one)
+  projection = ScalarProduct(n)/n.NormSquared();    // remove constancy from n (keep as logical one)
   // withdraw projected vector twice from original one
-  Log() << Verbose(1) << "Vector: ";
-  Output();
-  Log() << Verbose(0) << "\t";
   for (int i=NDIM;i--;)
-    x[i] -= 2.*projection*n->x[i];
-  Log() << Verbose(0) << "Projected vector: ";
-  Output();
-  Log() << Verbose(0) << endl;
-};
-
-/** Calculates normal vector for three given vectors (being three points in space).
- * Makes this vector orthonormal to the three given points, making up a place in 3d space.
- * \param *y1 first vector
- * \param *y2 second vector
- * \param *y3 third vector
- * \return true - success, vectors are linear independent, false - failure due to linear dependency
- */
-bool Vector::MakeNormalVector(const Vector * const y1, const Vector * const y2, const Vector * const y3)
-{
-  Vector x1, x2;
-
-  x1.CopyVector(y1);
-  x1.SubtractVector(y2);
-  x2.CopyVector(y3);
-  x2.SubtractVector(y2);
-  if ((fabs(x1.Norm()) < MYEPSILON) || (fabs(x2.Norm()) < MYEPSILON) || (fabs(x1.Angle(&x2)) < MYEPSILON)) {
-    eLog() << Verbose(2) << "Given vectors are linear dependent." << endl;
-    return false;
-  }
-//  Log() << Verbose(4) << "relative, first plane coordinates:";
-//  x1.Output((ofstream *)&cout);
-//  Log() << Verbose(0) << endl;
-//  Log() << Verbose(4) << "second plane coordinates:";
-//  x2.Output((ofstream *)&cout);
-//  Log() << Verbose(0) << endl;
-
-  this->x[0] = (x1.x[1]*x2.x[2] - x1.x[2]*x2.x[1]);
-  this->x[1] = (x1.x[2]*x2.x[0] - x1.x[0]*x2.x[2]);
-  this->x[2] = (x1.x[0]*x2.x[1] - x1.x[1]*x2.x[0]);
-  Normalize();
-
-  return true;
-};
-
-
-/** Calculates orthonormal vector to two given vectors.
- * Makes this vector orthonormal to two given vectors. This is very similar to the other
- * vector::MakeNormalVector(), only there three points whereas here two difference
- * vectors are given.
- * \param *x1 first vector
- * \param *x2 second vector
- * \return true - success, vectors are linear independent, false - failure due to linear dependency
- */
-bool Vector::MakeNormalVector(const Vector * const y1, const Vector * const y2)
-{
-  Vector x1,x2;
-  x1.CopyVector(y1);
-  x2.CopyVector(y2);
-  Zero();
-  if ((fabs(x1.Norm()) < MYEPSILON) || (fabs(x2.Norm()) < MYEPSILON) || (fabs(x1.Angle(&x2)) < MYEPSILON)) {
-    eLog() << Verbose(2) << "Given vectors are linear dependent." << endl;
-    return false;
-  }
-//  Log() << Verbose(4) << "relative, first plane coordinates:";
-//  x1.Output((ofstream *)&cout);
-//  Log() << Verbose(0) << endl;
-//  Log() << Verbose(4) << "second plane coordinates:";
-//  x2.Output((ofstream *)&cout);
-//  Log() << Verbose(0) << endl;
-
-  this->x[0] = (x1.x[1]*x2.x[2] - x1.x[2]*x2.x[1]);
-  this->x[1] = (x1.x[2]*x2.x[0] - x1.x[0]*x2.x[2]);
-  this->x[2] = (x1.x[0]*x2.x[1] - x1.x[1]*x2.x[0]);
-  Normalize();
-
-  return true;
+    at(i) -= 2.*projection*n[i];
 };
 
